package com.practice.migration.nov_10_23;

import freemarker.cache.NullCacheStorage;
import freemarker.cache.StringTemplateLoader;
import freemarker.core.ParseException;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import org.json.JSONObject;
import org.springframework.ui.Model;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;

public class FTLToIR {
    public void convertFTLtoIR() {


        try {
            // Initialize FreeMarker Configuration
            Configuration cfg = new Configuration(Configuration.VERSION_2_3_31);

            // FTL Template
            String ftlTemplate = "[#assign f=1]\n" +
                    "[#if f gt 0]\n" +
                    "  {f} > 0\n" +
                    "[#else]\n" +
                    "  {f} < 0\n" +
                    "[/#if]";

            // Load FTL Template
            StringTemplateLoader templateLoader = new StringTemplateLoader();
            templateLoader.putTemplate("myTemplate", ftlTemplate);
            cfg.setTemplateLoader(templateLoader);

            // Get the Template
            Template template = cfg.getTemplate("myTemplate");

            // Create a data model (context)
            Map<String, Object> dataModel = new HashMap<>();

            // Process the template
            StringWriter out = new StringWriter();
            template.process(dataModel, out);

            // Extract the result as a JSON object
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("IR", out.toString());

            // Print the IR JSON
            System.out.println("----- print thte data ----");
            System.out.println(jsonObject.toString(4)); // Pretty print with 4 spaces
            System.out.println(jsonObject +" :"+ jsonObject );
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }
}
