package com.practice.migration.nov_10_23;

import freemarker.cache.StringTemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;

import java.io.IOException;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;
public class FtlToIRConverter {

    public static void main(String[] args) {
        String ftlTemplate = "[#assign f=1]\n\n[#if f gt 0]\n  ${f} > 0\n[#else]\n  ${f} < 0\n[/#if]";

        try {
            Map<String, Object> dataModel = new HashMap<>();
            dataModel.put("f", 1);

            String irJson = convertFtlToIR(ftlTemplate, dataModel);
            System.out.println("Intermediate Representation (IR):");
            System.out.println(irJson);
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }

    private static String convertFtlToIR(String ftlTemplate, Map<String, Object> dataModel)
            throws IOException, TemplateException {
        Configuration cfg = new Configuration(Configuration.VERSION_2_3_31);
        StringTemplateLoader stringLoader = new StringTemplateLoader();
        stringLoader.putTemplate("myTemplate", ftlTemplate);
        cfg.setTemplateLoader(stringLoader);

        Template template = cfg.getTemplate("myTemplate");
        StringWriter writer = new StringWriter();
        template.process(dataModel, writer);

        return writer.toString();
    }
}
