package com.practice.migration.nov_10_23;

import javassist.*;

public class IRExtractor {
    public static void main(String[] args) {
        try {
            // Load the class
            ClassPool classPool = ClassPool.getDefault();
            CtClass ctClass = classPool.get("SampleClass");

            // Extracting fields
            CtField[] fields = ctClass.getDeclaredFields();
            for (CtField field : fields) {
                System.out.println("Field: " + field.getName());
            }

            // Extracting methods
            CtMethod[] methods = ctClass.getDeclaredMethods();
            for (CtMethod method : methods) {
                System.out.println("Method: " + method.getName());
            }

            // You can further explore the method bodies, annotations, etc.

        } catch (NotFoundException e) {
            e.printStackTrace();
        }
    }
}

class SampleClass {
    private int value;

    public SampleClass(int value) {
        this.value = value;
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
    }

    public void printValue() {
        System.out.println("Value: " + value);
    }
}