grammar FreeMarker;

// Parser rules
template: (tag | text)*;

tag: assignmentTag | conditionalTag;

assignmentTag: '#assign' ID '=' STRING;

conditionalTag: '#if' expression
    (tag | text)*
    ('#else'
        (tag | text)*
    )?
    '#end';

expression: ID ('>' | '<') NUMBER;

// Lexer rules
ID: [a-zA-Z]+;
NUMBER: [0-9]+;
STRING: '\'' ~'\''* '\'';
WS: [ \t\r\n]+ -> skip;

// Ignoring everything else for simplicity
ANY: . -> skip;