package com.practice.migration.nov_13_23.before;

import javax.tools.JavaCompiler;
import javax.tools.ToolProvider;
import java.io.*;

public class DynamicCompilationExample {

    public static void main(String[] args) throws Exception {
        // Java source code to be compiled dynamically
        String sourceCode = "public class DynamicClass {\n" +
                "    public void printMessage() {\n" +
                "        System.out.println(\"Hello from dynamically generated class!\");\n" +
                "    }\n" +
                "}\n";

        // Compile the source code
        compileAndRunDynamicClass("DynamicClass", sourceCode);
    }

    private static void compileAndRunDynamicClass(String className, String sourceCode) throws Exception {
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
//        StringWriter compilerOutput = new StringWriter();
        OutputStream compilerOutput = new FileOutputStream("D:\\testout.txt");  ;
        int compilationResult = compiler.run(null, null, compilerOutput, "-d", "./out", "-sourcepath", "./src", "-classpath",
                System.getProperty("java.class.path"), "-Xlint:unchecked", "-Xlint:deprecation", "-Xlint:rawtypes",
                "-Xlint:cast", "-Xlint:path", "-Xlint:processing", "-Xlint:-processing");

        if (compilationResult == 0) {
            try {
                // Load the dynamically compiled class
                Class<?> dynamicClass = Class.forName(className);
                Object instance = dynamicClass.getDeclaredConstructor().newInstance();

                // Call a method on the dynamically compiled class
                dynamicClass.getMethod("printMessage").invoke(instance);
            } catch (Exception e) {
                System.out.println("exception: "+ e);
                e.printStackTrace();
            }
        } else {
            // Print compilation errors
            System.out.println("Compilation failed:");
            System.err.println(compilerOutput.toString());
        }
    }
}