package com.practice.migration.nov_13_23.customParser.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.practice.migration.nov_13_23.customParser.model.common.MainTemplate;
import com.practice.migration.nov_13_23.customParser.model.request_and_response_body.FTLRequestBody;
import com.practice.migration.nov_13_23.customParser.model.request_and_response_body.JsonResponse;
import com.practice.migration.nov_13_23.customParser.service.HomeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/v1/api/")
public class HomeController {

    @Autowired
    private HomeService homeService;

    @GetMapping("ftl-to-json")
    public ResponseEntity<JsonResponse> getResponse(@RequestBody FTLRequestBody ftlRequestBody) {
        JsonResponse jsonResponse = null;
        try {
            jsonResponse = homeService.convertFTLtoJson(ftlRequestBody);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
        return new ResponseEntity<>(jsonResponse, HttpStatus.OK);
    }
}
