package com.practice.migration.nov_13_23.customParser.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ObjectWriter;
import com.practice.migration.nov_13_23.customParser.model.common.Children;
import com.practice.migration.nov_13_23.customParser.model.common.LittleChild;
import com.practice.migration.nov_13_23.customParser.model.common.MainTemplate;
import com.practice.migration.nov_13_23.customParser.model.if_else_block.IfElseBlock;
import com.practice.migration.nov_13_23.customParser.model.request_and_response_body.FTLRequestBody;
import com.practice.migration.nov_13_23.customParser.model.request_and_response_body.JsonResponse;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service
public class HomeService {

    public JsonResponse convertFTLtoJson(FTLRequestBody ftlRequestBody) throws JsonProcessingException {

        String ftlString = ftlRequestBody.getFtlString();

        IfElseBlock ifBlockFromFTL = getIfBlockFromFTL(ftlString);
//        getAssigment

//        System.out.println("result: "+ ifBlockFromFTL);
//        Children children = Children.builder()
//                .assignment(null)
//                .ifElseBlockList(Arrays.asList(ifBlockFromFTL))
//                .build();
//        MainTemplate template = MainTemplate.builder()
//                .TemplateName("template")
//                .childrenList(Arrays.asList(children))
//                .build();
        JsonResponse jsonResponse = new JsonResponse();
//        jsonResponse.setMainTemplate(template);
        ObjectWriter ow = new ObjectMapper().writer().withDefaultPrettyPrinter();
        String json = ow.writeValueAsString(jsonResponse);
        System.out.println("Response: "+ json);
        return  jsonResponse;
    }

    private static IfElseBlock getIfBlockFromFTL(String ftlString) {
        int startIndex = ftlString.indexOf("[#if");
        int endIndex = ftlString.indexOf("/#if]", startIndex );
        String result = ftlString.substring(startIndex, endIndex - 1); //+ 5
        String[] ifElseWords = result.split("\n");

        String substring = StringUtils.substring(ftlString, startIndex, endIndex + 1);
//        StringUtils.countMatches()
//        StringUtils.

//        System.out.println("words length from FTL: "+ ifElseWords.length);

        IfElseBlock ifElseBlock = new IfElseBlock();
        ifElseBlock.setType("conditional");
        Arrays.stream(ifElseWords)
                .filter(s -> (!s.equals(" ") || !s.equals("  ")))
                .forEach(s -> {
//                    System.out.println("words from FTL: "+ s);
                   buildIfElseBlockObject(s, ifElseBlock);
                });
//        System.out.println("---> main block ---> "+ ifElseBlock);
        return ifElseBlock;
    }

    private static void buildIfElseBlockObject(String linesDividedBy_N, IfElseBlock ifElseBlock) {

                    if (linesDividedBy_N.contains("if"))
                        ifElseBlock.setCondition(getCondition(linesDividedBy_N));
                    ifElseBlock.setTrueBranch(getTrueBranch(linesDividedBy_N));

    }

    private static List<LittleChild> getTrueBranch(String value) {
        ArrayList<LittleChild> littleChildren = new ArrayList<>();

        Arrays
                .stream(value.split(" "))
                        .forEach(data -> {
                            LittleChild littleChild = new LittleChild();
                            littleChild.setType(data.startsWith("${") ? "variable" : "text");
                            littleChild.setContent(data);
                            littleChildren.add(littleChild);
                        });

        return littleChildren;
    }

    private static String getCondition(String value) {
//        int startIndex = value.indexOf("[#if");
//        int endIndex = value.indexOf("]");
        return value.substring(4, value.length() - 1); //+
    }
}
