package com.practice.migration.nov_21_23.jsonLib;

import org.json.JSONArray;
import org.json.JSONObject;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

public class HTMLToJsonConverter {

    public static void main(String[] args) {
        String htmlString = "<div class=\"smart-bundling-cart-icon\">\n" +
                "            <img src=\"[@wsgc.docurl url='images/checkout/svg/cartDesktop1.svg'/]\"/>\n" +
                "            <img src=\"[@wsgc.docurl url='images/checkout/svg/cartDesktop3.svg'/]\"/>\n" +
                "            <img src=\"[@wsgc.docurl url='images/checkout/svg/cartDesktop2.svg'/]\"/>\n" +
                "            <div class='abc'>Test</div>\n" +
                "        </div>";

        Document doc = Jsoup.parse(htmlString);
        Element rootElement = doc.selectFirst("body > *");
//        System.out.println("doc --> "+ doc +"====> "+ rootElement);

        JSONObject json = new JSONObject();
        traverseAndBuildJson(rootElement, json);

        System.out.println(json);
    }

    private static void traverseAndBuildJson(Element element, JSONObject json) {
        json.put("tagName", element.tagName());
        if (!element.attributes().isEmpty()) {
            JSONObject attributes = new JSONObject();
            element
                    .attributes()
                    .forEach(attribute ->
                            attributes.put(attribute.getKey(), attribute.getValue())
                    );
            json.put("attributes", attributes);
        }

        Elements children = element.children();
        if (!children.isEmpty()) {
            JSONArray childrenArray = new JSONArray();
            for (Element child : children) {
                JSONObject childJson = new JSONObject();
                // Recursive nature --> building the children objects.
                traverseAndBuildJson(child, childJson);
                childrenArray.put(childJson);
            }
            json.put("children", childrenArray);
        }
    }
}

