package com.practice.migration.stringconvertion;

import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import freemarker.template.TemplateExceptionHandler;
import freemarker.template.Version;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;

public class FTLProcessor {

    public static void main(String[] args) {
        // Initialize FreeMarker configuration
        Configuration cfg = new Configuration(new Version("2.3.31"));
        cfg.setClassForTemplateLoading(FTLProcessor.class, "/templates");
        cfg.setDefaultEncoding("UTF-8");
        cfg.setTemplateExceptionHandler(TemplateExceptionHandler.RETHROW_HANDLER);

        // Data model (replace this with your data)
        Map<String, Object> data = new HashMap<>();
        data.put("name", "John");
//        data.put("age", 25);

        // Process FTL template
        try {
            Template template = cfg.getTemplate("example.ftl");

            // Create a StringWriter to capture the output
            try (Writer out = new StringWriter()) {
                // Process the template with the data model and write to the StringWriter
                template.process(data, out);

                // Get the content from the StringWriter
                String content = out.toString();
                System.out.println("FTL Template Output:\n" + content);

                // Here you can convert 'content' into an intermediate representation (IR)
                // This may involve parsing the content and converting it into a structured format.
                // For simplicity, we'll just print the content in this example.
                // Your actual logic for IR conversion would depend on your requirements.
                // ...

            } catch (TemplateException | IOException e) {
                e.printStackTrace();
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}