[#import '/macros/config.ftl' as config/]
[#import '/macros/pricedisplay.ftl' as pricedisplay/]
[#import '/macros/widgets.ftl' as widgets/]

[#assign productThumbnailSuffix = config.imageSuffixes.pipRecs /]
[#assign productSwatchThumbnailSuffix = config.imageSuffixes.guidedPipSwatchCopy /]

[#assign
    overlayTitle = "Review Your Made-to-Order Item"
    shipDelaySpecialMessage = "Select &quot;Accept Terms&quot; to acknowledge this policy and to continue to add this item to your cart. If you select Decline, this item will not be added."
    shipDelayAcceptButtonText = "Accept &amp; Add to Cart"
    shipDelayDeclineButtonText = "Decline"
/]

[#macro readyOverlay inFragment=false]
    [#if !wsgc.ison('pip', 'show_ship_delay_confirmation')]
        [#return]
    [/#if]

    [@widgets.overlay id='shipDelayConfirmation' inFragment=inFragment]
        [@alertJsTemplateContent/]
    [/@widgets.overlay]
[/#macro]

[#macro readyMobileOverlay]
    [#if !wsgc.ison('pip', 'show_ship_delay_confirmation')]
        [#return]
    [/#if]

    [@widgets.jstemplate id="shipDelayConfirmation"]
        <div class="sliding-overlay-confirmation ship-delay-confirmation-sliding-overlay">
            <div class="overlay overlay-collapsed">
                <div class="headline">
                    <a class="close closeComponent">x</a>
                </div>

                [@alertJsTemplateContent/]
            </div>
            <div class="mask closeComponent"></div>
        </div>
    [/@widgets.jstemplate]
[/#macro]

[#macro alertJsTemplateContent]
    <h3 class="primary-modal-header ship-delay-product-header">${overlayTitle}</h3>
    <ul class="ship-delay-confirmation-product-group">
        [% for (var i = 0; i ${'<'} products.length; i++) { %]
            <li class="ship-delay-confirmation-product">
                [#local productImgSrc = "${wsgcMacroHelper.catImageBase}/[%= products[i].image %]${productThumbnailSuffix}.jpg"/]
                [#local swatchImgSrc = "${wsgcMacroHelper.catImageBase}/[%= products[i].swatch %]${productSwatchThumbnailSuffix}.jpg"/]
                <h2 class="product-title">
                    [%= products[i].shortName %]
                </h2>
                <div class="ship-delay-confirmation-product-alert-message">
                    [%= products[i].shipDelayAlert %]
                </div>
                <img src="${productImgSrc}" class="ship-delay-confirmation-product-thumb" alt="Reference photo for [%= products[i].shortName %]"/>
                [% if( products[i].swatch ) { %]
                    <img src="${swatchImgSrc}" class="ship-delay-confirmation-product-swatch-thumb" alt="Reference swatch for [%= products[i].shortName %]"/>
                [% } %]
            </li>
        [% } %]
    </ul>
    <div class="ship-delay-confirmation-accept-terms">
        <p class="ship-delay-confirmation-call-to-action">${shipDelaySpecialMessage}</p>
        <div class="button-group">
            <button class="btn btn-primary js-accept-shipping-button">${shipDelayAcceptButtonText}</button>
            <button class="btn btn-secondary js-deny-shipping-button">${shipDelayDeclineButtonText}</button>
        </div>
    </div>
[/#macro]