package com.practice.migration.nov_13_23.customParser.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ObjectWriter;
import com.practice.migration.nov_13_23.customParser.model.assign.AssignmentBlock;
import com.practice.migration.nov_13_23.customParser.model.common.Children;
import com.practice.migration.nov_13_23.customParser.model.common.LittleChild;
import com.practice.migration.nov_13_23.customParser.model.common.MainTemplate;
import com.practice.migration.nov_13_23.customParser.model.if_else_block.IfElseBlock;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class Assign_IfElse_Block_HomeServiceImpl {
    private static final String FTL_String = "[#assign name_value='vinil'] \n" +
            "[#if age > 19]\n" +
            "  Welcome, ${name} to nisum family\n" +
            "[#else]\n" +
            "  You are too nisum young, ${name}!\n" +
            "[/#if]";

    static IfElseBlock ifElseBlock = new IfElseBlock();
    static AssignmentBlock assignmentBlock = new AssignmentBlock();
    static Children children = new Children();
    public static void main(String[] ar) throws JsonProcessingException {

        getResponseFromIfElseBlock();
        getResponseFromAssignBlock();
        children.setAssignment(assignmentBlock);
        children.setIfElseBlockList(List.of(ifElseBlock));
        MainTemplate mainTemplate = new MainTemplate();
        mainTemplate.setTemplateName("template");
        mainTemplate.setChildrenList(List.of(children));

        ObjectWriter ow = new ObjectMapper().writer().withDefaultPrettyPrinter();
        String json = ow.writeValueAsString(mainTemplate);
        System.out.println("Response: "+ json);
    }

    private static void getResponseFromAssignBlock() {

        int startIndex = FTL_String.indexOf("#assign");
        int endIndex = FTL_String.indexOf("]");
        String substring = FTL_String.substring(startIndex + 7, endIndex); // added 7 because of removeing the #assign from the string.
        String[] variableAndName = substring.split("\n");
        assignmentBlock.setType("Assignment");
        String[] variableAndNameArray = variableAndName[0].split("=");
        assignmentBlock.setVariable(variableAndNameArray[0]);
        assignmentBlock.setValue(variableAndNameArray[1]);
    }

    private static void getResponseFromIfElseBlock() {
        ifElseBlock.setType("template");
        int startIndex = FTL_String.indexOf("[#if" );
        int endIndex = FTL_String.indexOf("[#else]" );

        String response = FTL_String.substring(startIndex, endIndex);

        String[] split = response.split("\n");

//        System.out.println("condition--> " + getCondition(split));
        ifElseBlock.setCondition(getCondition(split));
        ifElseBlock.setTrueBranch(getChildrenBranch(split[1]));

        getChildrenBranch(split[1]);
        String elseString = FTL_String.substring(endIndex);
        int last = FTL_String.indexOf("[/#if]");
        String[] split1 = elseString.split("\n");
        getChildrenBranch(split1[1]);
        ifElseBlock.setFalseBranch(getChildrenBranch(split1[1]));
//        System.out.println("Final block: "+ ifElseBlock);
    }
    private static List <LittleChild> getChildrenBranch(String s) {

        ArrayList<LittleChild> littleChildren = new ArrayList<>();
        if(s.contains("${")) {
            String between = StringUtils.substringBetween(s, "${", "}");
            int startIndex = s.indexOf(between) - 2;
            int endIndex = startIndex + between.length() + 3;

            String before = s.substring(0, startIndex);
            littleChildren.add(getLittleChild(before, "text"));

            String inBetween = s.substring(startIndex, endIndex);
            littleChildren.add( getLittleChild(inBetween, "Variable"));

            String after = s.substring(endIndex);
            littleChildren.add(getLittleChild(after, "text"));

//            System.out.print("Final ----> Before "+ before + " Custom name "+ inBetween +" after "+ after);
            } else {
            littleChildren.add(getLittleChild(s.trim(), "text"));
        }
        return littleChildren ;
    }

    private static LittleChild getLittleChild(String key, String value) {
        LittleChild littleChildInBetween = new LittleChild();
        littleChildInBetween.setType(key);
        littleChildInBetween.setContent(value);
        return littleChildInBetween;
    }

    private static String getCondition(String[] value) {

        int startIndex = value[0].indexOf("[#if");
        int endIndex = value[0].indexOf("]");
        String substring = value[0].substring(startIndex + 4,endIndex);
        return substring;
    }
}
